﻿package {
	import com.robotacid.dungeon.Map;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Aaron Steed, robotacid.com
	 */
	
	[SWF(width = "640", height = "480", frameRate = "60", backgroundColor = "#000000")]
	
	public class Main extends Sprite {
		
		public var dungeon:Map;
		
		public static const MIN_ROOM_WIDTH:int = 3;
		public static const MIN_ROOM_HEIGHT:int = 2;
		
		public static const UP:int = 1;
		public static const RIGHT:int = 2;
		public static const DOWN:int = 4;
		public static const LEFT:int = 8;
		
		public function Main():void {
			scaleX = 2;
			scaleY = 2;
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			stage.addEventListener(MouseEvent.CLICK, onClick);
			addEventListener(Event.ENTER_FRAME, loop);
			dungeon = new Map(3, this);
			
		}
		public function onClick(e:MouseEvent = null):void{
			while(numChildren > 0) removeChildAt(0);
			dungeon = new Map(3, this);
		}
		private function loop(e:Event = null):void{
			dungeon.main();
		}
		
	}
	
}